#include "zcommon.acs"
#library "arc"

#include "commonFuncs.h"
#include "arcConst.h"
#include "arcFuncs.h"

script 191 open
{
    SetDBEntry("arc", "zandtest", 1);
    Arc_IsZand = GetDBEntry("arc", "zandtest");

    while (true)
    {
        ACS_ExecuteWithResult(ARCSCRIPT_SWITCH, 0);
        Delay(1);
    }
}

script ARCSCRIPT (int arctype)
{
    int myTID = defaultTID(-1);
    int myAngle = GetActorAngle(0);
    int myPitch = GetActorPitch(0);
    int enemyTID;
    int tx, ty, tz;
    int tid1;
    int i, j;

    int myx = GetActorX(0);
    int myy = GetActorY(0);
    int myz = GetActorZ(0);
    int myrange = itof(GetActorProperty(0, APROP_Damage));

    SetActivator(0, AAPTR_TARGET);
    int myPln  = PlayerNumber();
    int myTeam = GetPlayerInfo(myPln, PLAYERINFO_TEAM);
    SetActivator(myTID);

    if (ArcTypes_Int[arctype][ARC_I_OLDLOOK])
    {
        SetActorState(0, "DoLookOld");

        if (GameType() == GAME_NET_DEATHMATCH)
        {
            GiveInventory("PopgunUnfriendly", 1);                
            SetActorState(0, "DoLookOld");
            GiveInventory("PopgunFriendly", 1);                
        }

        // no target found
        if (ACS_ExecuteWithResult(ARCSCRIPT_SWITCH, 2))
        {
            if (ArcTypes_Int[arctype][ARC_I_AUTO_UNFRIEND])
            {
                ACS_ExecuteWithResult(ARCSCRIPT_SWITCH, 0);
            }

            SetActorState(0, "EndArc");
            terminate;
        }

        SetActivator(0, AAPTR_TRACER);

        enemyTID = defaultTID(-1);
        tx = GetActorX(0);
        ty = GetActorY(0);
        tz = GetActorZ(0) + GetActorViewHeight(0);
    }
    else
    {
        // keep track of which arc this is
        G_FOUND = 0;
        G_ARCNUM++;

        // vector of the direction the arc is facing
        int fx   = FixedMul(cos(myAngle), cos(myPitch));
        int fy   = FixedMul(sin(myAngle), cos(myPitch));
        int fz   =          sin(myPitch);

        for (i = 0; i < myrange; i += 32.0)
        {
            j = min(myrange, i + 32.0);

            if (G_FOUND && (G_BESTTARGET[NEAR_PRIORITY] < j))
            {
                break;
            }

            SetActivator(myTID);
            SetActorProperty(0, APROP_Health, ftoi(j));

            while (true)
            {
                if (FindTarget(arctype, myrange, myTID, myx, myy, myz, fx, fy, fz, myPln, myTeam))
                {
                    break;
                }
            }

            if (GameType() == GAME_NET_DEATHMATCH)
            {
                GiveInventory("PopgunUnfriendly", 1);                

                while (true)
                {
                    if (FindTarget(arctype, myrange, myTID, myx, myy, myz, fx, fy, fz, myPln, myTeam))
                    {
                        break;
                    }
                }

                GiveInventory("PopgunFriendly", 1);                
            }
        }


        SetActivator(myTID);
        ClearChecked();

        if (!G_FOUND)
        {
            if (ArcTypes_Int[arctype][ARC_I_AUTO_UNFRIEND])
            {
                ACS_ExecuteWithResult(ARCSCRIPT_SWITCH, 0);
            }

            SetActorState(0, "EndArc");
            terminate;
        }

        enemyTID = G_BESTTARGET[NEAR_TID];
        tx       = G_BESTTARGET[NEAR_X];
        ty       = G_BESTTARGET[NEAR_Y];
        tz       = G_BESTTARGET[NEAR_Z];

        SetPointer(AAPTR_TRACER, enemyTID);
    }

    BEAMTHEFUCKOUTMOTHERFUCKER(myx, myy, myz, tx, ty, tz, arctype);

    SetActivator(myTID);

    tid1 = unusedTID(15000, 19000);

    int arcpoint = ArcTypes_Str[arctype][ARC_S_POINT];
    Spawn(arcpoint, tx,ty,tz, tid1);

    SetActorAngle(tid1, GetActorAngle(0));

    SetActivator(0, AAPTR_TARGET);
    GiveInventory("PopshotCounter", 1);

    SetActivator(tid1);

    SetPointer(AAPTR_TARGET, myTID, AAPTR_TARGET);
    SetPointer(AAPTR_TRACER, myTID, AAPTR_TRACER);

    SetActorState(0, "Pop");

    SetActivator(myTID, AAPTR_TRACER);

    SetActorProperty(0, APROP_Friendly, true);
    FriendlyTIDs[FriendlyTIDCount++] = enemyTID;

    SetActivator(tid1);
    SetActorState(0, "BeginArc");
}

script ARCSCRIPT_SWITCH (int which, int a1, int a2)
{
    int result;

    int i;
    int tid, x, y, z, myTID, myx, myy, myz;
    int arcactor;

    switch (which)
    {
    // clear friendliness
      case 0:
        for (i = 0; i < FriendlyTIDCount; i++)
        {
            SetActorProperty(FriendlyTIDs[i], APROP_Friendly, false);
        }

        FriendlyTIDCount = 0;
        break;

      case 1:
        myx = GetActorX(0);
        myy = GetActorY(0);
        myz = GetActorZ(0);

        SetActivatorToTarget(0);

        x = GetActorX(0);
        y = GetActorY(0);
        z = GetActorZ(0) + GetActorViewHeight(0) - 12.0;

        BEAMTHEFUCKOUTMOTHERFUCKER(x, y, z, myx, myy, myz, a1);
        break;

      case 2:
        SetActivator(0, AAPTR_TRACER);
        result = (ClassifyActor(0) & ACTOR_WORLD) == ACTOR_WORLD;
        break;

    // first arc actor - from bullet
      case 3:
        SetActorAngle(0, GetActorAngle(0) + 0.5);
        // fall through

    // first arc actor - from projectile
      case 4:
        ACS_ExecuteWithResult(ARCSCRIPT_SWITCH, 5);
        ACS_ExecuteWithResult(ARCSCRIPT, a1);
        break;

      case 5:
        SetActivatorToTarget(0);
        TakeInventory("PopshotCounter", 0x7FFFFFFF);
        break;

    // spawn arc actor, and do first arc
      case 6:
        myTID = defaultTID(-1);
        x = GetActorX(0);
        y = GetActorY(0);
        z = GetActorZ(0);
        
        tid = unusedTID(23000, 27000);
        arcactor = ArcTypes_Str[a1][ARC_S_POINT];

        SpawnForced(arcactor, x,y,z, tid);
        SetActorAngle(tid, GetActorAngle(0));
        SetActorPitch(tid, GetActorPitch(0));

        SetActivator(tid);
        SetPointer(AAPTR_TARGET, myTID, AAPTR_TARGET);
        SetPointer(AAPTR_MASTER, myTID, AAPTR_MASTER);
        SetPointer(AAPTR_TRACER, myTID, AAPTR_TRACER);

        ACS_ExecuteWithResult(ARCSCRIPT_SWITCH, 5);
        ACS_ExecuteWithResult(ARCSCRIPT, a1);
        break;

      case 7:
        Log(n:0, s:" ", d:ActivatorTID(), s:" is now ",
            s:cond(GetActorProperty(0, APROP_FRIENDLY), "\cdFRIENDLY\c-", "\caUNFRIENDLY\c-"));
        break;
    }

    SetResultValue(result);
}

script ARCSCRIPT_BEAM (int startpoint, int endpoint, int arctype) clientside
{
    if (ConsolePlayerNumber() == -1) { terminate; }

    int x1 = GetActorX(startpoint);
    int y1 = GetActorY(startpoint);
    int z1 = GetActorZ(startpoint);

    int x2 = GetActorX(endpoint);
    int y2 = GetActorY(endpoint);
    int z2 = GetActorZ(endpoint);

    OMGABEAM(x1,y1,z1, x2,y2,z2, arctype);
}
