function void BEAMTHEFUCKOUTMOTHERFUCKER(int x1, int y1, int z1, int x2, int y2, int z2, int arctype)
{
    int beamscript = ArcTypes_Int[arctype][ARC_I_BEAMSCRIPT];

    int tid1 = unusedTID(24000, 28000);
    int tid2 = unusedTID(28000, 32000);

    SpawnForced("ArcBeamDummy", x1, y1, z1, tid1);
    SpawnForced("ArcBeamDummy", x2, y2, z2, tid2);

    ACS_ExecuteAlways(beamscript, 0, tid1, tid2, arctype);
}

function void OMGABEAM(int x1, int y1, int z1, int x2, int y2, int z2, int beamtype)
{
    int i;

    int vx = x2-x1;
    int vy = y2-y1;
    int vz = z2-z1;

    int mag = magnitudeThree_f(vx, vy, vz);
    int magI = ftoi(mag);

    int nx = FixedDiv(vx, mag);
    int ny = FixedDiv(vy, mag);
    int nz = FixedDiv(vz, mag);

    int start   = ArcTypes_Int[beamtype][ARC_I_BEAMSTART];
    int density = ArcTypes_Int[beamtype][ARC_I_BEAMDENSITY];
    int trail   = ArcTypes_Str[beamtype][ARC_S_BEAMACTOR];

    for (i = start; i < magI; i += density)
    {
        SpawnForced(trail, x1+(nx*i), y1+(ny*i), z1+(nz*i));
    }
}

function void AddChecked(int tid)
{
    CheckedTIDs[CheckedTIDCount++] = tid;
    SetActorProperty(tid, APROP_Friendly, true);
}

function void ClearChecked(void)
{
    int isFriend, i, j, tid1, tid2;

    for (i = 0; i < CheckedTIDCount; i++)
    {
        tid1 = CheckedTIDs[i];
        isFriend = false;

        for (j = 0; j < FriendlyTIDCount; j++)
        {
            tid2 = FriendlyTIDs[j];
            if (tid1 == tid2) { isFriend = true; }
        }

        if (!isFriend)
        {
            SetActorProperty(tid1, APROP_Friendly, false);
        }
    }

    CheckedTIDCount = 0;
}

function int FindTarget(int arctype, int arcrange, int myTID, int myx, int myy, int myz, int fx, int fy, int fz, int myPln, int myTeam)
{
    SetActorState(myTID, "DoLook");

    // found everyone
    if (ACS_ExecuteWithResult(ARCSCRIPT_SWITCH, 2))
    {
        return -1;
    }

    SetActivator(myTID, AAPTR_TRACER);
    int enemyTID = defaultTID(-1);

    if (GetActorProperty(0, APROP_Friendly))
    {
        AddChecked(enemyTID);
        return 0;
    }

    if (CheckInventory("PopshotArcTracker") == G_ARCNUM)
    {
        AddChecked(enemyTID);
        return 0;
    }

    int pln = PlayerNumber();

    if (myPln >= 0 && pln == myPln)
    {
        AddChecked(enemyTID);
        return 0;
    }

    if ((Arc_IsZand && myTeam != 4) || (!Arc_IsZand && myTeam != 255))
    {
        if (GetPlayerInfo(pln, PLAYERINFO_TEAM) == myTeam)
        {
            AddChecked(enemyTID);
            return 0;
        }
    }

    SetInventory("PopshotArcTracker", G_ARCNUM);

    int tx = GetActorX(0);
    int ty = GetActorY(0);
    int tz = GetActorZ(0) + GetActorViewHeight(0);
    
    int dx = tx - myx;
    int dy = ty - myy;
    int dz = tz - myz;
    int dmag = magnitudeThree_f(dx, dy, dz);

    // only goes up from dmag

    if (G_FOUND && G_BESTTARGET[NEAR_PRIORITY] <= dmag)
    {
        AddChecked(enemyTID);
        return 0;
    }

    // calculate difference between 3D angles
    //  acos(dot3(vec1, vec2) / (mag(vec1) * mag(vec2)))

    int angleDiff;
    int enemyPriority;
    int angleWeight = ArcTypes_Int[arctype][ARC_I_ANGLEWEIGHT];

    switch (angleWeight)
    {
      default:
        angleDiff     = 1.0 - acos(FixedDiv(dot3(fx, fy, fz, dx, dy, dz), dmag));
        enemyPriority = FixedDiv(dmag, FixedMul(1.8, angleDiff));
        enemyPriority = (dmag + enemyPriority) - FixedMul(1.0 - angleWeight, enemyPriority);
        break;

      case 0.0:
        enemyPriority = dmag;
        break;

      case 1.0:
        angleDiff     = 1.0 - acos(FixedDiv(dot3(fx, fy, fz, dx, dy, dz), dmag));
        enemyPriority = FixedDiv(dmag, FixedMul(1.8, angleDiff));
        break;
    }

    if (G_FOUND && G_BESTTARGET[NEAR_PRIORITY] <= enemyPriority)
    {
        AddChecked(enemyTID);
        return 0;
    }

    if (dmag <= arcrange)
    {
        G_BESTTARGET[NEAR_TID]      = enemyTID;
        G_BESTTARGET[NEAR_PRIORITY] = enemyPriority;
        G_BESTTARGET[NEAR_DIST]     = dmag;
        G_BESTTARGET[NEAR_X]        = tx;
        G_BESTTARGET[NEAR_Y]        = ty;
        G_BESTTARGET[NEAR_Z]        = tz;

        G_FOUND = true;
    }

    AddChecked(enemyTID);
    return 0;
}


